#!/usr/bin/ruby
#
# :main:README
# :title:edi4r-tdid
#
# UN/EDIFACT add-on module: UN/TDIDs - UN Trade Data Interchange directories
#
# == Synopsis
#
#  Prepend this gem's data directory to the global
#  searchpath for "normdatabases" in EDI_NDB_PATH
#
# == Usage
#
#   require 'edi4r-tdid'
#
#
# == Description
#
#  The edi4r base gem comes with only a few samples of UN/EDIFACT
#  normdata. This add-on provides the full collection of
#  UN Trade Data Interchange Directories (TDIDs), including those
#  distributed with the base gem.
#
#  We put this gem's data directory in front of the searchpath,
#  because it is usually the most frequently used one.
#
# == Environment
#
#  EDI_NDB_PATH
#
# :include: ../AuthorCopyright
#

module EDI::TDID # This is for RDoc only
end

BEGIN {

  require 'pathname'

# 'realpath' fails on Windows platforms!
#  path_to_add = Pathname.new(__FILE__).dirname.parent.realpath + 'data'
  pdir = Pathname.new(__FILE__).dirname.parent
  path_to_add =  File.expand_path(pdir) + File::Separator + 'data'

  paths = (ENV['EDI_NDB_PATH'] || '').split(/#{File::PATH_SEPARATOR}/)
  unless paths.include? path_to_add
    paths.unshift path_to_add
    ENV['EDI_NDB_PATH'] = paths.join File::PATH_SEPARATOR
  end

}
